KDE 4.7 PyKDE API Reference

- KDE's Python API

# KXMLGUIFactory Class Reference

`from PyKDE4.kdeui import *`

Inherits: QObject

## Detailed Description

KXMLGUIFactory, together with KXMLGUIClient objects, can be used to create a GUI of container widgets (like menus, toolbars, etc.) and container items (menu items, toolbar buttons, etc.) from an XML document and action objects.

Each KXMLGUIClient represents a part of the GUI, composed from containers and actions. KXMLGUIFactory takes care of building (with the help of a KXMLGUIBuilder) and merging the GUI from an unlimited number of clients.

Each client provides XML through a QDomDocument and actions through a KActionCollection . The XML document contains the rules for how to merge the GUI.

KXMLGUIFactory processes the DOM tree provided by a client and plugs in the client's actions, according to the XML and the merging rules of previously inserted clients. Container widgets are built via a KXMLGUIBuilder , which has to be provided with the KXMLGUIFactory constructor.

## Signals
| clientAdded (KXMLGUIClient client)
| clientRemoved (KXMLGUIClient client)
| makingChanges (bool a0)
## Methods
| __init__ (self, KXMLGUIBuilder builder, QObject parent=0)
| addClient (self, KXMLGUIClient client)
| changeShortcutScheme (self, QString scheme)
[KXMLGUIClient] | clients (self)
int | configureShortcuts (self, bool bAllowLetterShortcuts=1, bool bSaveSettings=1)
QWidget | container (self, QString containerName, KXMLGUIClient client, bool useTagName=0)
[QWidget] | containers (self, QString tagName)
| plugActionList (self, KXMLGUIClient client, QString name, [QAction] actionList)
| refreshActionProperties (self)
| removeClient (self, KXMLGUIClient client)
| reset (self)
| resetContainer (self, QString containerName, bool useTagName=0)
| unplugActionList (self, KXMLGUIClient client, QString name)
## Static Methods
QDomElement | actionPropertiesElement (QDomDocument doc)
QDomElement | findActionByName (QDomElement elem, QString sName, bool create)
QString | readConfigFile (QString filename, KComponentData componentData=KComponentData())
bool | saveConfigFile (QDomDocument doc, QString filename, KComponentData componentData=KComponentData())

## Signal Documentation

clientAdded | ( | KXMLGUIClient | client
| ) |  |  |

Signal syntax:
  `QObject.connect(source, SIGNAL("clientAdded(KXMLGUIClient*)"), target_slot)`

clientRemoved | ( | KXMLGUIClient | client
| ) |  |  |

Signal syntax:
  `QObject.connect(source, SIGNAL("clientRemoved(KXMLGUIClient*)"), target_slot)`

makingChanges | ( | bool | a0
| ) |  |  |

Emitted when the factory is currently making changes to the GUI, i.e. adding or removing clients. makingChanges(true) is emitted before any change happens, and makingChanges(false) is emitted after the change is done. This allows e.g. KMainWindow to know that the GUI is being changed programmatically and not by the user (so there is no reason to save toolbar settings afterwards).

Since:
  4.1.3

Signal syntax:
  `QObject.connect(source, SIGNAL("makingChanges(bool)"), target_slot)`

## Method Documentation

__init__ | ( | self, |
|  | KXMLGUIBuilder | builder,
|  | QObject | parent=0
| ) |  |  |

Constructs a KXMLGUIFactory. The provided builder KXMLGUIBuilder will be called for creating and removing container widgets, when clients are added/removed from the GUI.

Note that the ownership of the given KXMLGUIBuilder object won't be transferred to this KXMLGUIFactory, so you have to take care of deleting it properly.

addClient | ( | self, |
|  | KXMLGUIClient | client
| ) |  |  |

Creates the GUI described by the QDomDocument of the client, using the client's actions, and merges it with the previously created GUI. This also means that the order in which clients are added to the factory is relevant; assuming that your application supports plugins, you should first add your application to the factory and then the plugin, so that the plugin's UI is merged into the UI of your application, and not the other way round.

changeShortcutScheme | ( | self, |
|  | QString | scheme
| ) |  |  |

[KXMLGUIClient] clients | ( |  | self ) |

Returns a list of all clients currently added to this factory

int configureShortcuts | ( | self, |
|  | bool | bAllowLetterShortcuts=1,
|  | bool | bSaveSettings=1
| ) |  |  |

Show a standard configure shortcut for every action in this factory.

This slot can be connected directly to the action to configure shortcuts. This is very simple to do that by adding a single line

     KStandardAction.keyBindings( guiFactory(), SLOT( configureShortcuts() ), actionCollection() );

Parameters:

  | bAllowLetterShortcuts | Set to false if unmodified alphanumeric keys ('A', '1', etc.) are not permissible shortcuts.
  | bSaveSettings | if true, the settings will also be saved back to the *uirc file which they were intially read from.

QWidget container | ( | self, |
|  | QString | containerName,
|  | KXMLGUIClient | client,
|  | bool | useTagName=0
| ) |  |  |

Use this method to get access to a container widget with the name specified with containerName and which is owned by the client. The container name is specified with a "name" attribute in the XML document.

This function is particularly useful for getting hold of a popupmenu defined in an XMLUI file. For instance:

     QMenu *popup = static_cast<QMenu*>(guiFactory()->container("my_popup",this));

where "my_popup" is the name of the menu in the XMLUI file, and "this" is XMLGUIClient which owns the popupmenu (e.g. the mainwindow, or the part, or the plugin...)

Parameters:

  | containerName | Name of the container widget
  | client | Owner of the container widget
  | useTagName | Specifies whether to compare the specified name with the name attribute or the tag name.

This method may return 0 if no container with the given name exists or is not owned by the client.

[QWidget] containers | ( | self, |
|  | QString | tagName
| ) |  |  |

plugActionList | ( | self, |
|  | KXMLGUIClient | client,
|  | QString | name,
|  | [QAction] | actionList
| ) |  |  |

refreshActionProperties | ( |  | self ) |

Use this method to reset and reread action properties (shortcuts, etc.) for all actions. This is needed, for example, when you change shortcuts scheme at runtime.

removeClient | ( | self, |
|  | KXMLGUIClient | client
| ) |  |  |

Removes the GUI described by the client, by unplugging all provided actions and removing all owned containers (and storing container state information in the given client)

reset | ( |  | self ) |

Use this method to free all memory allocated by the KXMLGUIFactory. This deletes the internal node tree and therefore resets the internal state of the class. Please note that the actual GUI is NOT touched at all, meaning no containers are deleted nor any actions unplugged. That is something you have to do on your own. So use this method only if you know what you are doing :-)

(also note that this will call KXMLGUIClient.setFactory( 0 ) for all inserted clients)

resetContainer | ( | self, |
|  | QString | containerName,
|  | bool | useTagName=0
| ) |  |  |

Use this method to free all memory allocated by the KXMLGUIFactory for a specific container, including all child containers and actions. This deletes the internal node subtree for the specified container. The actual GUI is not touched, no containers are deleted or any actions unplugged. Use this method only if you know what you are doing :-)

(also note that this will call KXMLGUIClient.setFactory( 0 ) for all clients of the container)

unplugActionList | ( | self, |
|  | KXMLGUIClient | client,
|  | QString | name
| ) |  |  |

## Static Method Documentation

QDomElement actionPropertiesElement | ( | QDomDocument | doc
| ) |  |  |

Internal:
  Find or create the ActionProperties element, used when saving custom action properties

QDomElement findActionByName | ( | QDomElement | elem,
|  | QString | sName,
|  | bool | create
| ) |  |  |

Internal:
  Find or create the element for a given action, by name. Used when saving custom action properties

QString readConfigFile | ( | QString | filename,
|  | KComponentData | componentData=KComponentData()
| ) |  |  |

bool saveConfigFile | ( | QDomDocument | doc,
|  | QString | filename,
|  | KComponentData | componentData=KComponentData()
| ) |  |  |